// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from ublox_ubx_msgs:msg/OrbEphInfo.idl
// generated code does not contain a copyright notice

#include "ublox_ubx_msgs/msg/detail/orb_eph_info__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_ublox_ubx_msgs
const rosidl_type_hash_t *
ublox_ubx_msgs__msg__OrbEphInfo__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xae, 0x81, 0x02, 0x5c, 0x55, 0x91, 0x8a, 0x8d,
      0x7a, 0x27, 0x3b, 0xf3, 0x98, 0x22, 0x69, 0xb7,
      0x68, 0x6e, 0x56, 0x07, 0x25, 0xc6, 0x40, 0x8e,
      0x96, 0x3b, 0xa5, 0x84, 0xa4, 0x60, 0x46, 0xd9,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char ublox_ubx_msgs__msg__OrbEphInfo__TYPE_NAME[] = "ublox_ubx_msgs/msg/OrbEphInfo";

// Define type names, field names, and default values
static char ublox_ubx_msgs__msg__OrbEphInfo__FIELD_NAME__eph_usability[] = "eph_usability";
static char ublox_ubx_msgs__msg__OrbEphInfo__FIELD_NAME__eph_source[] = "eph_source";

static rosidl_runtime_c__type_description__Field ublox_ubx_msgs__msg__OrbEphInfo__FIELDS[] = {
  {
    {ublox_ubx_msgs__msg__OrbEphInfo__FIELD_NAME__eph_usability, 13, 13},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {ublox_ubx_msgs__msg__OrbEphInfo__FIELD_NAME__eph_source, 10, 10},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
ublox_ubx_msgs__msg__OrbEphInfo__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {ublox_ubx_msgs__msg__OrbEphInfo__TYPE_NAME, 29, 29},
      {ublox_ubx_msgs__msg__OrbEphInfo__FIELDS, 2, 2},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# Bit field structure for eph\n"
  "uint8 EPH_USABILITY_UNKNOWN = 31      # The usability period is unknown\n"
  "uint8 EPH_USABILITY_OVER_450_MIN = 30 # The usability period is more than 450 minutes\n"
  "uint8 EPH_USABILITY_EXPIRED = 0       # Ephemeris can no longer be used\n"
  "uint8 eph_usability                   # How long the receiver will be able to use the stored ephemeris data from now on.\n"
  "                                      # For 30 > n > 0, the usability period is between (n-1)*15 and n*15 minutes.\n"
  "\n"
  "uint8 EPH_SOURCE_NOT_AVAILABLE = 0\n"
  "uint8 EPH_SOURCE_GNSS_TRANSMISSION = 1\n"
  "uint8 EPH_SOURCE_EXTERNAL_AIDING = 2\n"
  "uint8 eph_source                     # Ephemeris source";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
ublox_ubx_msgs__msg__OrbEphInfo__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {ublox_ubx_msgs__msg__OrbEphInfo__TYPE_NAME, 29, 29},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 663, 663},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
ublox_ubx_msgs__msg__OrbEphInfo__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *ublox_ubx_msgs__msg__OrbEphInfo__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
